Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 4516)
+++ palm/trunk/SOURCE/Makefile	(revision 4517)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# dependencies for MPI-IO added
+# 
+# 4513 2020-04-30 13:45:47Z raasch
 # dependencies from chemistry modules updated
 # 
@@ -460,4 +463,5 @@
 	palm_date_time_mod.o \
 	radiation_model_mod.o \
+	restart_data_mpi_io_mod.o \
 	surface_mod.o
 chem_gasphase_mod.o: \
Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4517)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -365,5 +368,6 @@
 !-- Read local restart parameters
     INTERFACE bio_rrd_local
-       MODULE PROCEDURE bio_rrd_local
+       MODULE PROCEDURE bio_rrd_local_ftn
+       MODULE PROCEDURE bio_rrd_local_mpi
     END INTERFACE bio_rrd_local
 !
@@ -1429,7 +1433,7 @@
 ! Description:
 ! ------------
-!> Soubroutine reads local biometeorology configuration from restart file(s)
-!------------------------------------------------------------------------------!
- SUBROUTINE bio_rrd_local( found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_rrd_local_ftn( found )
 
 
@@ -1465,5 +1469,18 @@
 
 
- END SUBROUTINE bio_rrd_local
+ END SUBROUTINE bio_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE bio_rrd_local_mpi
+
+    STOP '+++ reading restart data with MPI-IO not implemented for bio_rrd_local_mpi'
+
+ END SUBROUTINE bio_rrd_local_mpi
+
 
 !------------------------------------------------------------------------------!
Index: palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4506 2020-04-21 10:57:45Z schwenkel
 ! Use correct magnus formula for liquid water temperature
 ! 
@@ -183,5 +186,5 @@
 
     USE restart_data_mpi_io_mod,                                               &
-        ONLY:  rrd_mpi_io, wrd_mpi_io
+        ONLY:  rd_mpi_io_check_array, rrd_mpi_io, wrd_mpi_io
 
     USE statistics,                                                            &
@@ -404,5 +407,6 @@
 
     INTERFACE bcm_rrd_local
-       MODULE PROCEDURE bcm_rrd_local
+       MODULE PROCEDURE bcm_rrd_local_ftn
+       MODULE PROCEDURE bcm_rrd_local_mpi
     END INTERFACE bcm_rrd_local
 
@@ -3397,9 +3401,9 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the bulk cloud module.
-!------------------------------------------------------------------------------!
-    SUBROUTINE bcm_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
-                              nxr_on_file, nynf, nync, nyn_on_file, nysf,      &
-                              nysc, nys_on_file, tmp_2d, tmp_3d, found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+    SUBROUTINE bcm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
+                                  nxr_on_file, nynf, nync, nyn_on_file, nysf,      &
+                                  nysc, nys_on_file, tmp_2d, tmp_3d, found )
 
 
@@ -3432,8 +3436,4 @@
        REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !<
 
-!
-!-- Here the reading of user-defined restart data follows:
-!-- Sample for user-defined output
-
 
        found = .TRUE.
@@ -3561,5 +3561,107 @@
 
 
-    END SUBROUTINE bcm_rrd_local
+    END SUBROUTINE bcm_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE bcm_rrd_local_mpi
+
+       LOGICAL ::  array_found  !<
+
+
+       CALL rd_mpi_io_check_array( 'prr' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( prr ) )  ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'prr', prr )
+       ENDIF
+
+       CALL rd_mpi_io_check_array( 'prr_av' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( prr_av ) )  ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'prr_av', prr_av )
+       ENDIF
+
+       CALL rd_mpi_io_check_array( 'precipitation_amount' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( precipitation_amount ) )  THEN
+             ALLOCATE( precipitation_amount(nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          CALL rrd_mpi_io( 'precipitation_amount', precipitation_amount )
+       ENDIF
+
+       CALL rrd_mpi_io( 'ql', ql )
+
+       CALL rd_mpi_io_check_array( 'ql_av' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( ql_av ) )  ALLOCATE( ql_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'ql_av', ql_av )
+       ENDIF
+
+       CALL rrd_mpi_io( 'qc', qc )
+
+       CALL rd_mpi_io_check_array( 'qc_av' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( qc_av ) )  ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'qc_av', qc_av )
+       ENDIF
+
+       IF ( microphysics_morrison )  THEN
+
+          CALL rrd_mpi_io( 'nc', nc )
+
+          CALL rd_mpi_io_check_array( 'nc_av' , found = array_found )
+          IF ( array_found )  THEN
+             IF ( .NOT. ALLOCATED( nc_av ) )  ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             CALL rrd_mpi_io( 'nc_av', nc_av )
+          ENDIF
+
+       ENDIF
+
+       IF ( microphysics_seifert )  THEN
+
+          CALL rrd_mpi_io( 'nr', nr )
+
+          CALL rd_mpi_io_check_array( 'nr_av' , found = array_found )
+          IF ( array_found )  THEN
+             IF ( .NOT. ALLOCATED( nr_av ) )  ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             CALL rrd_mpi_io( 'nr_av', nr_av )
+          ENDIF
+
+          CALL rrd_mpi_io( 'qr', qr )
+
+          CALL rd_mpi_io_check_array( 'qr_av' , found = array_found )
+          IF ( array_found )  THEN
+             IF ( .NOT. ALLOCATED( qr_av ) )  ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             CALL rrd_mpi_io( 'qr_av', qr_av )
+          ENDIF
+
+       ENDIF
+
+       IF ( microphysics_ice_extension )  THEN
+
+          CALL rrd_mpi_io( 'ni', ni )
+
+          CALL rd_mpi_io_check_array( 'ni_av' , found = array_found )
+          IF ( array_found )  THEN
+             IF ( .NOT. ALLOCATED( ni_av ) )  ALLOCATE( ni_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             CALL rrd_mpi_io( 'ni_av', ni_av )
+          ENDIF
+
+          CALL rrd_mpi_io( 'qi', qi )
+
+          CALL rd_mpi_io_check_array( 'qi_av' , found = array_found )
+          IF ( array_found )  THEN
+             IF ( .NOT. ALLOCATED( qi_av ) )  ALLOCATE( qi_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             CALL rrd_mpi_io( 'qi_av', qi_av )
+          ENDIF
+
+       ENDIF
+
+
+    END SUBROUTINE bcm_rrd_local_mpi
 
 
Index: palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4517)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO
+! 
+! 4511 2020-04-30 12:20:40Z raasch
 ! decycling replaced by explicit setting of lateral boundary conditions
 !
@@ -312,4 +315,5 @@
                 max_pr_user,                                                                       &
                 monotonic_limiter_z,                                                               &
+                restart_data_format_output,                                                        &
                 scalar_advec,                                                                      &
                 timestep_scheme, use_prescribed_profile_data, ws_scheme_sca, air_chemistry
@@ -329,4 +333,7 @@
     USE cpulog,                                                                                    &
         ONLY:  cpu_log, log_point_s
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io, wrd_mpi_io
 
     USE statistics
@@ -501,5 +508,6 @@
 
     INTERFACE chem_rrd_local
-       MODULE PROCEDURE chem_rrd_local
+       MODULE PROCEDURE chem_rrd_local_ftn
+       MODULE PROCEDURE chem_rrd_local_mpi
     END INTERFACE chem_rrd_local
 
@@ -3042,9 +3050,9 @@
 ! Description:
 ! ------------
-!> Subroutine to read restart data of chemical species
-!------------------------------------------------------------------------------!
- SUBROUTINE chem_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,             &
-                            nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,   &
-                            nys_on_file, tmp_3d, found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE chem_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,             &
+                                nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,   &
+                                nys_on_file, tmp_3d, found )
 
     USE control_parameters
@@ -3076,5 +3084,5 @@
 
 
-    IF ( ALLOCATED(chem_species) )  THEN
+    IF ( ALLOCATED( chem_species ) )  THEN
 
        DO  lsp = 1, nspec
@@ -3105,5 +3113,30 @@
 
 
- END SUBROUTINE chem_rrd_local
+ END SUBROUTINE chem_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE chem_rrd_local_mpi
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  lsp !<
+
+    IF ( ALLOCATED( chem_species ) )  THEN
+
+       DO  lsp = 1, nspec
+
+          CALL rrd_mpi_io( TRIM( chem_species(lsp)%name ), chem_species(lsp)%conc )
+          CALL rrd_mpi_io( TRIM( chem_species(lsp)%name )//'_av', chem_species(lsp)%conc_av )
+
+       ENDDO
+
+    ENDIF
+
+ END SUBROUTINE chem_rrd_local_mpi
 
 
@@ -3208,10 +3241,21 @@
     INTEGER(iwp) ::  lsp  !< running index for chem spcs. 
 
-    DO  lsp = 1, nspec
-       CALL wrd_write_string( TRIM( chem_species(lsp)%name ) )
-       WRITE ( 14 )  chem_species(lsp)%conc
-       CALL wrd_write_string( TRIM( chem_species(lsp)%name )//'_av' )
-       WRITE ( 14 )  chem_species(lsp)%conc_av
-    ENDDO
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       DO  lsp = 1, nspec
+          CALL wrd_write_string( TRIM( chem_species(lsp)%name ) )
+          WRITE ( 14 )  chem_species(lsp)%conc
+          CALL wrd_write_string( TRIM( chem_species(lsp)%name )//'_av' )
+          WRITE ( 14 )  chem_species(lsp)%conc_av
+       ENDDO
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       DO  lsp = 1, nspec
+          CALL wrd_mpi_io( TRIM( chem_species(lsp)%name ), chem_species(lsp)%conc )
+          CALL wrd_mpi_io( TRIM( chem_species(lsp)%name ) // '_av', chem_species(lsp)%conc_av )
+       ENDDO
+
+    ENDIF
 
  END SUBROUTINE chem_wrd_local
Index: palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90
===================================================================
--- palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4517)
@@ -110,4 +110,5 @@
                data_output,                                                    &
                message_string,                                                 &
+               restart_data_format_output,                                     &
                varnamelength
 !
@@ -1942,4 +1943,5 @@
 !> Note: With the current structure reading of non-standard array is not
 !> possible
+!> COMMENT:  these arrays should be given standard index bounds! (Siggi)
 !------------------------------------------------------------------------------!
 !  SUBROUTINE doq_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,             &
@@ -2048,69 +2050,77 @@
     IMPLICIT NONE
 
-    IF ( ALLOCATED( pt_2m_av ) )  THEN
-       CALL wrd_write_string( 'pt_2m_av' )
-       WRITE ( 14 )  pt_2m_av
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       IF ( ALLOCATED( pt_2m_av ) )  THEN
+          CALL wrd_write_string( 'pt_2m_av' )
+          WRITE ( 14 )  pt_2m_av
+       ENDIF
+
+       IF ( ALLOCATED( ti_av ) )  THEN
+          CALL wrd_write_string( 'ti_av' )
+          WRITE ( 14 )  ti_av
+       ENDIF
+
+       IF ( ALLOCATED( uu_av ) )  THEN
+          CALL wrd_write_string( 'uu_av' )
+          WRITE ( 14 )  uu_av
+       ENDIF
+
+       IF ( ALLOCATED( uv_10m_av ) )  THEN
+          CALL wrd_write_string( 'uv_10m_av' )
+          WRITE ( 14 )  uv_10m_av
+       ENDIF
+
+       IF ( ALLOCATED( vv_av ) )  THEN
+          CALL wrd_write_string( 'vv_av' )
+          WRITE ( 14 )  vv_av
+       ENDIF
+
+       IF ( ALLOCATED( ww_av ) )  THEN
+          CALL wrd_write_string( 'ww_av' )
+          WRITE ( 14 )  ww_av
+       ENDIF
+
+       IF ( ALLOCATED( wu_av ) )  THEN
+          CALL wrd_write_string( 'wu_av' )
+          WRITE ( 14 )  wu_av
+       ENDIF
+
+       IF ( ALLOCATED( wv_av ) )  THEN
+          CALL wrd_write_string( 'wv_av' )
+          WRITE ( 14 )  wv_av
+       ENDIF
+
+       IF ( ALLOCATED( wtheta_av ) )  THEN
+          CALL wrd_write_string( 'wtheta_av' )
+          WRITE ( 14 )  wtheta_av
+       ENDIF
+
+       IF ( ALLOCATED( wq_av ) )  THEN
+          CALL wrd_write_string( 'wq_av' )
+          WRITE ( 14 )  wq_av
+       ENDIF
+
+       IF ( ALLOCATED( wspeed_av ) )  THEN
+          CALL wrd_write_string( 'wspeed_av' )
+          WRITE ( 14 )  wspeed_av
+       ENDIF
+
+       IF ( ALLOCATED( u_center_av ) )  THEN
+          CALL wrd_write_string( 'u_center_av' )
+          WRITE ( 14 )  u_center_av
+       ENDIF
+
+       IF ( ALLOCATED( v_center_av ) )  THEN
+          CALL wrd_write_string( 'v_center_av' )
+          WRITE ( 14 )  v_center_av
+       ENDIF
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       STOP 'mpi-io for doq_wrd_local not realized'
+
     ENDIF
 
-    IF ( ALLOCATED( ti_av ) )  THEN
-       CALL wrd_write_string( 'ti_av' )
-       WRITE ( 14 )  ti_av
-    ENDIF
-
-    IF ( ALLOCATED( uu_av ) )  THEN
-       CALL wrd_write_string( 'uu_av' )
-       WRITE ( 14 )  uu_av
-    ENDIF
-
-    IF ( ALLOCATED( uv_10m_av ) )  THEN
-       CALL wrd_write_string( 'uv_10m_av' )
-       WRITE ( 14 )  uv_10m_av
-    ENDIF
-
-    IF ( ALLOCATED( vv_av ) )  THEN
-       CALL wrd_write_string( 'vv_av' )
-       WRITE ( 14 )  vv_av
-    ENDIF
-
-    IF ( ALLOCATED( ww_av ) )  THEN
-       CALL wrd_write_string( 'ww_av' )
-       WRITE ( 14 )  ww_av
-    ENDIF
-
-    IF ( ALLOCATED( wu_av ) )  THEN
-       CALL wrd_write_string( 'wu_av' )
-       WRITE ( 14 )  wu_av
-    ENDIF
-
-    IF ( ALLOCATED( wv_av ) )  THEN
-       CALL wrd_write_string( 'wv_av' )
-       WRITE ( 14 )  wv_av
-    ENDIF
-
-    IF ( ALLOCATED( wtheta_av ) )  THEN
-       CALL wrd_write_string( 'wtheta_av' )
-       WRITE ( 14 )  wtheta_av
-    ENDIF
-
-    IF ( ALLOCATED( wq_av ) )  THEN
-       CALL wrd_write_string( 'wq_av' )
-       WRITE ( 14 )  wq_av
-    ENDIF
-
-    IF ( ALLOCATED( wspeed_av ) )  THEN
-       CALL wrd_write_string( 'wspeed_av' )
-       WRITE ( 14 )  wspeed_av
-    ENDIF
-
-    IF ( ALLOCATED( u_center_av ) )  THEN
-       CALL wrd_write_string( 'u_center_av' )
-       WRITE ( 14 )  u_center_av
-    ENDIF
-
-    IF ( ALLOCATED( v_center_av ) )  THEN
-       CALL wrd_write_string( 'v_center_av' )
-       WRITE ( 14 )  v_center_av
-    ENDIF
-
  END SUBROUTINE doq_wrd_local
 
Index: palm/trunk/SOURCE/dynamics_mod.f90
===================================================================
--- palm/trunk/SOURCE/dynamics_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/dynamics_mod.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4505 2020-04-20 15:37:15Z schwenkel
 ! Add flag for saturation check
 ! 
@@ -279,5 +282,6 @@
 
     INTERFACE dynamics_rrd_local
-       MODULE PROCEDURE dynamics_rrd_local
+       MODULE PROCEDURE dynamics_rrd_local_ftn
+       MODULE PROCEDURE dynamics_rrd_local_mpi
     END INTERFACE dynamics_rrd_local
 
@@ -1871,11 +1875,11 @@
 ! Description:
 ! ------------
-!> Read module-specific processor specific restart data from file(s).
+!> Read module-specific local restart data arrays (Fortran binary format).
 !> Subdomain index limits on file are given by nxl_on_file, etc.
 !> Indices nxlc, etc. indicate the range of gridpoints to be mapped from the subdomain on file (f)
 !> to the subdomain of the current PE (c). They have been calculated in routine rrd_local.
 !--------------------------------------------------------------------------------------------------!
- SUBROUTINE dynamics_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc, nxr_on_file, nynf, nync,   &
-                                nyn_on_file, nysf, nysc, nys_on_file, tmp_2d, tmp_3d, found )
+ SUBROUTINE dynamics_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc, nxr_on_file, nynf, nync,   &
+                                    nyn_on_file, nysf, nysc, nys_on_file, tmp_2d, tmp_3d, found )
 
 
@@ -1920,5 +1924,29 @@
     END SELECT
 
- END SUBROUTINE dynamics_rrd_local
+ END SUBROUTINE dynamics_rrd_local_ftn
+
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE dynamics_rrd_local_mpi
+
+    IMPLICIT NONE
+
+!    LOGICAL ::  array_found  !<
+
+
+!    CALL rd_mpi_io_check_array( 'u2_av' , found = array_found )
+!    IF ( array_found )  THEN
+!       IF ( .NOT. ALLOCATED( u2_av ) )  ALLOCATE( u2_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!       CALL rrd_mpi_io( 'u2_av', u2_av )
+!    ENDIF
+
+    CONTINUE
+
+ END SUBROUTINE dynamics_rrd_local_mpi
+
 
 
Index: palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- palm/trunk/SOURCE/gust_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/gust_mod.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -186,5 +189,6 @@
 
     INTERFACE gust_rrd_local
-       MODULE PROCEDURE gust_rrd_local
+       MODULE PROCEDURE gust_rrd_local_ftn
+       MODULE PROCEDURE gust_rrd_local_mpi
     END INTERFACE gust_rrd_local
 
@@ -618,9 +622,9 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the gust module.
-!------------------------------------------------------------------------------!
-    SUBROUTINE gust_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
-                               nxr_on_file, nynf, nync, nyn_on_file, nysf,     &
-                               nysc, nys_on_file, tmp_2d, tmp_3d, found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+    SUBROUTINE gust_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,         &
+                                   nxr_on_file, nynf, nync, nyn_on_file, nysf,     &
+                                   nysc, nys_on_file, tmp_2d, tmp_3d, found )
 
 
@@ -686,5 +690,18 @@
 
 
-    END SUBROUTINE gust_rrd_local
+    END SUBROUTINE gust_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE gust_rrd_local_mpi
+
+
+!       CALL rrd_mpi_io( 'local_array', local_array )
+
+    END SUBROUTINE gust_rrd_local_mpi
 
 
Index: palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4517)
@@ -210,5 +210,5 @@
 
     USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  rrd_mpi_io, wrd_mpi_io
+        ONLY:  rd_mpi_io_check_array, rrd_mpi_io, wrd_mpi_io
 
     USE statistics,                                                            &
@@ -413,5 +413,6 @@
 
     INTERFACE lpm_rrd_local
-       MODULE PROCEDURE lpm_rrd_local
+       MODULE PROCEDURE lpm_rrd_local_ftn
+       MODULE PROCEDURE lpm_rrd_local_mpi
     END INTERFACE lpm_rrd_local
 
@@ -3021,7 +3022,12 @@
  
  
- SUBROUTINE lpm_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
-                              nxr_on_file, nynf, nync, nyn_on_file, nysf,  &
-                              nysc, nys_on_file, tmp_3d, found )
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE lpm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
+                               nxr_on_file, nynf, nync, nyn_on_file, nysf,  &
+                               nysc, nys_on_file, tmp_3d, found )
 
 
@@ -3101,7 +3107,54 @@
        END SELECT
 
-
- END SUBROUTINE lpm_rrd_local
+ END SUBROUTINE lpm_rrd_local_ftn
+
  
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE lpm_rrd_local_mpi
+
+    IMPLICIT NONE
+
+    LOGICAL ::  array_found  !<
+
+    CALL rrd_mpi_io( 'iran', iran ) ! matching random numbers is still unresolved issue
+    CALL rrd_mpi_io( 'iran_part', iran_part )
+
+    CALL rd_mpi_io_check_array( 'pc_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( pc_av ) )  ALLOCATE( pc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'pc_av', pc_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'pr_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( pr_av ) )  ALLOCATE( pr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'pr_av', pr_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'ql_c_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( ql_c_av ) )  ALLOCATE( ql_c_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'ql_c_av', ql_c_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'ql_v_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( ql_v_av ) )  ALLOCATE( ql_v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'ql_v_av', ql_v_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'ql_vp_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( ql_vp_av ) )  ALLOCATE( ql_vp_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'ql_vp_av', ql_vp_av )
+    ENDIF
+
+ END SUBROUTINE lpm_rrd_local_mpi
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -3168,7 +3221,15 @@
 #endif
 
-    CALL wrd_write_string( 'iran' ) 
-    WRITE ( 14 )  iran, iran_part 
-
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+       CALL wrd_write_string( 'iran' )  ! matching random numbers is still unresolved issue
+       WRITE ( 14 )  iran, iran_part
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       CALL wrd_mpi_io( 'iran', iran )  ! matching random numbers is still unresolved issue
+       CALL wrd_mpi_io( 'iran_part', iran_part )
+
+    ENDIF
 
  END SUBROUTINE lpm_wrd_local
